// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"
	json "encoding/json"
	"fmt"

	v1 "github.com/openshift/api/oauth/v1"
	oauthv1 "github.com/openshift/client-go/oauth/applyconfigurations/oauth/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeUserOAuthAccessTokens implements UserOAuthAccessTokenInterface
type FakeUserOAuthAccessTokens struct {
	Fake *FakeOauthV1
}

var useroauthaccesstokensResource = v1.SchemeGroupVersion.WithResource("useroauthaccesstokens")

var useroauthaccesstokensKind = v1.SchemeGroupVersion.WithKind("UserOAuthAccessToken")

// Get takes name of the userOAuthAccessToken, and returns the corresponding userOAuthAccessToken object, and an error if there is any.
func (c *FakeUserOAuthAccessTokens) Get(ctx context.Context, name string, options metav1.GetOptions) (result *v1.UserOAuthAccessToken, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootGetAction(useroauthaccesstokensResource, name), &v1.UserOAuthAccessToken{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.UserOAuthAccessToken), err
}

// List takes label and field selectors, and returns the list of UserOAuthAccessTokens that match those selectors.
func (c *FakeUserOAuthAccessTokens) List(ctx context.Context, opts metav1.ListOptions) (result *v1.UserOAuthAccessTokenList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootListAction(useroauthaccesstokensResource, useroauthaccesstokensKind, opts), &v1.UserOAuthAccessTokenList{})
	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1.UserOAuthAccessTokenList{ListMeta: obj.(*v1.UserOAuthAccessTokenList).ListMeta}
	for _, item := range obj.(*v1.UserOAuthAccessTokenList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested userOAuthAccessTokens.
func (c *FakeUserOAuthAccessTokens) Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewRootWatchAction(useroauthaccesstokensResource, opts))
}

// Create takes the representation of a userOAuthAccessToken and creates it.  Returns the server's representation of the userOAuthAccessToken, and an error, if there is any.
func (c *FakeUserOAuthAccessTokens) Create(ctx context.Context, userOAuthAccessToken *v1.UserOAuthAccessToken, opts metav1.CreateOptions) (result *v1.UserOAuthAccessToken, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootCreateAction(useroauthaccesstokensResource, userOAuthAccessToken), &v1.UserOAuthAccessToken{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.UserOAuthAccessToken), err
}

// Update takes the representation of a userOAuthAccessToken and updates it. Returns the server's representation of the userOAuthAccessToken, and an error, if there is any.
func (c *FakeUserOAuthAccessTokens) Update(ctx context.Context, userOAuthAccessToken *v1.UserOAuthAccessToken, opts metav1.UpdateOptions) (result *v1.UserOAuthAccessToken, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootUpdateAction(useroauthaccesstokensResource, userOAuthAccessToken), &v1.UserOAuthAccessToken{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.UserOAuthAccessToken), err
}

// Delete takes name of the userOAuthAccessToken and deletes it. Returns an error if one occurs.
func (c *FakeUserOAuthAccessTokens) Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewRootDeleteActionWithOptions(useroauthaccesstokensResource, name, opts), &v1.UserOAuthAccessToken{})
	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeUserOAuthAccessTokens) DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error {
	action := testing.NewRootDeleteCollectionAction(useroauthaccesstokensResource, listOpts)

	_, err := c.Fake.Invokes(action, &v1.UserOAuthAccessTokenList{})
	return err
}

// Patch applies the patch and returns the patched userOAuthAccessToken.
func (c *FakeUserOAuthAccessTokens) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.UserOAuthAccessToken, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(useroauthaccesstokensResource, name, pt, data, subresources...), &v1.UserOAuthAccessToken{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.UserOAuthAccessToken), err
}

// Apply takes the given apply declarative configuration, applies it and returns the applied userOAuthAccessToken.
func (c *FakeUserOAuthAccessTokens) Apply(ctx context.Context, userOAuthAccessToken *oauthv1.UserOAuthAccessTokenApplyConfiguration, opts metav1.ApplyOptions) (result *v1.UserOAuthAccessToken, err error) {
	if userOAuthAccessToken == nil {
		return nil, fmt.Errorf("userOAuthAccessToken provided to Apply must not be nil")
	}
	data, err := json.Marshal(userOAuthAccessToken)
	if err != nil {
		return nil, err
	}
	name := userOAuthAccessToken.Name
	if name == nil {
		return nil, fmt.Errorf("userOAuthAccessToken.Name must be provided to Apply")
	}
	obj, err := c.Fake.
		Invokes(testing.NewRootPatchSubresourceAction(useroauthaccesstokensResource, *name, types.ApplyPatchType, data), &v1.UserOAuthAccessToken{})
	if obj == nil {
		return nil, err
	}
	return obj.(*v1.UserOAuthAccessToken), err
}
